% ============= analiz_lipreder.m ===================
%==     -   ===
% x -  () 
% nseg - -   
% sdvig -   
% b -   
% sigma -   
% ==================================================
fs=11025;             %  
nseg=256;             % -   
por_fil = 15;           %  
sdvig=nseg;           %  

tic   %  
b=[];
sigma=[];
for i= 1:sdvig:(length(x)-nseg)     %    ( 0%)
      for j=1:nseg
         xseg(j)=x(i+j-1);       %  i- 
      end;
   [Kxseg,lags] = xcov(xseg,por_fil,'biased');  % ..
   Kxseg_=Kxseg; Kxseg_(1:por_fil)=[];  % .. .-
   Kxseg_(por_fil+1)=[];  % .  .-
   Kxtep=toeplitz(Kxseg_);   %   
   Kxseg(1:(por_fil+1))=[];  %  .-  .

%======    =======
   b_seg=-Kxtep\Kxseg';  %   . - (nseg/2+1)  
   
%======   =======
   sig_seg=sqrt(Kxseg_(1)+sum(b_seg.*Kxseg'));

%======  b   sigma ===========
b=[b b_seg];   %  .
sigma=[sigma sig_seg];
end;
%  

toc   %  
% =====   ======
it= 1/fs:sdvig/fs:(length(x)-nseg)/fs;
figure;plot(it,sigma)
title('   ()');
xlabel(', '); ylabel(''); title(' ');

% ======  - b =======
jb=1:por_fil;
figure; imagesc(it,jb,b), axis xy, colormap(jet);
xlabel(', '); ylabel(' - bk'); title('  ');

% =====   =====
nfft = 128; fs = 11025;
window = rectwin(nfft); numoverlap = 0;
[B,f,t] = specgram(x,nfft,fs,window,numoverlap);
Bamp2=[];
for ib= 1:size(b,2)     %    ( 50%)
bk1=b(:,ib);bks1=[1 bk1'];           %   
sig=sigma(ib);
    [Bamp2_seg,Bf]=freqz(sig,bks1,65);
    Bamp2=[Bamp2 Bamp2_seg];
end
Bamp2=abs(Bamp2);
%    
figure; imagesc(t,f,20*log10(Bamp2)), axis xy, colormap(jet);
xlabel(', '); ylabel(', '); title(' ');